diff --git a/src/or/circuitbuild.c b/src/or/circuitbuild.c
index 17e7c14..aecd5d0 100644
--- a/src/or/circuitbuild.c
+++ b/src/or/circuitbuild.c
@@ -2600,7 +2600,7 @@ node_handles_some_port(const node_t *node, smartlist_t *needed_ports)
     port = *(uint16_t *)smartlist_get(needed_ports, i);
     tor_assert(port);
     if (node)
-      r = compare_addr_to_node_policy(0, port, node);
+      r = compare_tor_addr_to_node_policy(NULL, port, node);
     else
       continue;
     if (r != ADDR_POLICY_REJECTED && r != ADDR_POLICY_PROBABLY_REJECTED)
@@ -3290,11 +3290,9 @@ extend_info_alloc(const char *nickname, const char *digest,
 extend_info_t *
 extend_info_from_router(const routerinfo_t *r)
 {
-  tor_addr_t addr;
   tor_assert(r);
-  tor_addr_from_ipv4h(&addr, r->addr);
   return extend_info_alloc(r->nickname, r->cache_info.identity_digest,
-                           r->onion_pkey, &addr, r->or_port);
+                           r->onion_pkey, &r->addr, r->or_port);
 }
 
 /** Allocate and return a new extend_info that can be used to build a ircuit
@@ -3308,12 +3306,10 @@ extend_info_from_node(const node_t *node)
   if (node->ri) {
     return extend_info_from_router(node->ri);
   } else if (node->rs && node->md) {
-    tor_addr_t addr;
-    tor_addr_from_ipv4h(&addr, node->rs->addr);
     return extend_info_alloc(node->rs->nickname,
                              node->identity,
                              node->md->onion_pkey,
-                             &addr,
+                             &node->rs->addr,
                              node->rs->or_port);
   } else {
     return NULL;
@@ -4513,7 +4509,7 @@ clear_bridge_list(void)
  * (either by comparing keys if possible, else by comparing addr/port).
  * Else return NULL. */
 static bridge_info_t *
-get_configured_bridge_by_addr_port_digest(tor_addr_t *addr, uint16_t port,
+get_configured_bridge_by_addr_port_digest(const tor_addr_t *addr, uint16_t port,
                                           const char *digest)
 {
   if (!bridge_list)
@@ -4521,7 +4517,7 @@ get_configured_bridge_by_addr_port_digest(tor_addr_t *addr, uint16_t port,
   SMARTLIST_FOREACH_BEGIN(bridge_list, bridge_info_t *, bridge)
     {
       if (tor_digest_is_zero(bridge->identity) &&
-          !tor_addr_compare(&bridge->addr, addr, CMP_EXACT) &&
+          !tor_addr_eq(&bridge->addr, addr) &&
           bridge->port == port)
         return bridge;
       if (tor_memeq(bridge->identity, digest, DIGEST_LEN))
@@ -4536,9 +4532,7 @@ get_configured_bridge_by_addr_port_digest(tor_addr_t *addr, uint16_t port,
 static bridge_info_t *
 get_configured_bridge_by_routerinfo(const routerinfo_t *ri)
 {
-  tor_addr_t addr;
-  tor_addr_from_ipv4h(&addr, ri->addr);
-  return get_configured_bridge_by_addr_port_digest(&addr,
+  return get_configured_bridge_by_addr_port_digest(&ri->addr,
                               ri->or_port, ri->cache_info.identity_digest);
 }
 
@@ -4737,19 +4731,16 @@ rewrite_node_address_for_bridge(const bridge_info_t *bridge, node_t *node)
    *   do that safely if we know that no function that connects to an OR
    *   does so through an address from any source other than node_get_addr().
    */
-  tor_addr_t addr;
-
   if (node->ri) {
     routerinfo_t *ri = node->ri;
-    tor_addr_from_ipv4h(&addr, ri->addr);
 
-    if (!tor_addr_compare(&bridge->addr, &addr, CMP_EXACT) &&
+    if (!tor_addr_eq(&bridge->addr, &ri->addr) &&
         bridge->port == ri->or_port) {
       /* they match, so no need to do anything */
     } else {
-      ri->addr = tor_addr_to_ipv4h(&bridge->addr);
+      tor_addr_copy(&ri->addr, &bridge->addr);
       tor_free(ri->address);
-      ri->address = tor_dup_ip(ri->addr);
+      ri->address = tor_dup_ip(&ri->addr);
       ri->or_port = bridge->port;
       log_info(LD_DIR,
                "Adjusted bridge routerinfo for '%s' to match configured "
@@ -4759,13 +4750,11 @@ rewrite_node_address_for_bridge(const bridge_info_t *bridge, node_t *node)
   }
   if (node->rs) {
     routerstatus_t *rs = node->rs;
-    tor_addr_from_ipv4h(&addr, rs->addr);
-
-    if (!tor_addr_compare(&bridge->addr, &addr, CMP_EXACT) &&
+    if (!tor_addr_eq(&bridge->addr, &rs->addr) &&
         bridge->port == rs->or_port) {
       /* they match, so no need to do anything */
     } else {
-      rs->addr = tor_addr_to_ipv4h(&bridge->addr);
+      tor_addr_copy(&rs->addr, &bridge->addr);
       rs->or_port = bridge->port;
       log_info(LD_DIR,
                "Adjusted bridge routerstatus for '%s' to match "
diff --git a/src/or/circuituse.c b/src/or/circuituse.c
index 6e98e53..1b5e394 100644
--- a/src/or/circuituse.c
+++ b/src/or/circuituse.c
@@ -519,7 +519,7 @@ circuit_stream_is_being_handled(edge_connection_t *conn,
           ok = connection_ap_can_use_exit(conn, exitnode);
         } else {
           addr_policy_result_t r;
-          r = compare_addr_to_node_policy(0, port, exitnode);
+          r = compare_tor_addr_to_node_policy(NULL, port, exitnode);
           ok = r != ADDR_POLICY_REJECTED && r != ADDR_POLICY_PROBABLY_REJECTED;
         }
         if (ok) {
@@ -1271,11 +1271,14 @@ circuit_get_open_circ_or_launch(edge_connection_t *conn,
   /* Do we need to check exit policy? */
   if (check_exit_policy) {
     if (!conn->chosen_exit_name) {
-      struct in_addr in;
-      uint32_t addr = 0;
-      if (tor_inet_aton(conn->socks_request->address, &in))
-        addr = ntohl(in.s_addr);
-      if (router_exit_policy_all_nodes_reject(addr,
+      tor_addr_t addr;
+      if (!tor_inet_pton(AF_UNSPEC, conn->socks_request->address, &addr)) {
+        log_notice(LD_APP,
+                   "Could not parse address %s. Rejecting.",
+                   safe_str_client(conn->socks_request->address));
+        return -1;
+      }
+      if (router_exit_policy_all_nodes_reject(&addr,
                                               conn->socks_request->port,
                                               need_uptime)) {
         log_notice(LD_APP,
diff --git a/src/or/config.c b/src/or/config.c
index 1a877b8..feaa84e 100644
--- a/src/or/config.c
+++ b/src/or/config.c
@@ -2406,7 +2406,7 @@ list_torrc_options(void)
 }
 
 /** Last value actually set by resolve_my_address. */
-static uint32_t last_resolved_addr = 0;
+static tor_addr_t last_resolved_addr;
 /**
  * Based on <b>options-\>Address</b>, guess our public IP address and put it
  * (in host order) into *<b>addr_out</b>. If <b>hostname_out</b> is provided,
@@ -2416,10 +2416,9 @@ static uint32_t last_resolved_addr = 0;
  */
 int
 resolve_my_address(int warn_severity, or_options_t *options,
-                   uint32_t *addr_out, char **hostname_out)
+                   tor_addr_t *addr_out, char **hostname_out)
 {
-  struct in_addr in;
-  uint32_t addr; /* host order */
+  tor_addr_t addr;
   char hostname[256];
   int explicit_ip=1;
   int explicit_hostname=1;
@@ -2446,11 +2445,10 @@ resolve_my_address(int warn_severity, or_options_t *options,
 
   /* now we know hostname. resolve it and keep only the IP address */
 
-  if (tor_inet_aton(hostname, &in) == 0) {
+  if (tor_inet_pton(AF_UNSPEC, hostname, &addr) == 0) {
     /* then we have to resolve it */
     explicit_ip = 0;
-    if (tor_lookup_hostname(hostname, &addr)) { /* failed to resolve */
-      uint32_t interface_ip; /* host order */
+    if (tor_addr_lookup(hostname, AF_UNSPEC, &addr)) { /* failed to resolve */
 
       if (explicit_hostname) {
         log_fn(warn_severity, LD_CONFIG,
@@ -2460,49 +2458,45 @@ resolve_my_address(int warn_severity, or_options_t *options,
       log_fn(notice_severity, LD_CONFIG,
              "Could not resolve guessed local hostname '%s'. "
              "Trying something else.", hostname);
-      if (get_interface_address(warn_severity, &interface_ip)) {
+      if (get_interface_address6(warn_severity, AF_UNSPEC, &addr)) {
         log_fn(warn_severity, LD_CONFIG,
                "Could not get local interface IP address. Failing.");
         return -1;
       }
       from_interface = 1;
-      addr = interface_ip;
       log_fn(notice_severity, LD_CONFIG, "Learned IP address '%s' for "
-             "local interface. Using that.", fmt_addr32(addr));
+             "local interface. Using that.", fmt_addr(&addr));
       strlcpy(hostname, "<guessed from interfaces>", sizeof(hostname));
     } else { /* resolved hostname into addr */
       if (!explicit_hostname &&
-          is_internal_IP(addr, 0)) {
-        uint32_t interface_ip;
+          tor_addr_is_internal(&addr, 0)) {
 
         log_fn(notice_severity, LD_CONFIG, "Guessed local hostname '%s' "
                "resolves to a private IP address (%s). Trying something "
-               "else.", hostname, fmt_addr32(addr));
+               "else.", hostname, fmt_addr(&addr));
 
-        if (get_interface_address(warn_severity, &interface_ip)) {
+        if (get_interface_address6(warn_severity, AF_UNSPEC, &addr)) {
           log_fn(warn_severity, LD_CONFIG,
                  "Could not get local interface IP address. Too bad.");
-        } else if (is_internal_IP(interface_ip, 0)) {
+        } else if (tor_addr_is_internal(&addr, 0)) {
           log_fn(notice_severity, LD_CONFIG,
                  "Interface IP address '%s' is a private address too. "
-                 "Ignoring.", fmt_addr32(interface_ip));
+                 "Ignoring.", fmt_addr(&addr));
         } else {
           from_interface = 1;
-          addr = interface_ip;
           log_fn(notice_severity, LD_CONFIG,
                  "Learned IP address '%s' for local interface."
-                 " Using that.", fmt_addr32(addr));
+                 " Using that.", fmt_addr(&addr));
           strlcpy(hostname, "<guessed from interfaces>", sizeof(hostname));
         }
       }
     }
   } else {
-    addr = ntohl(in.s_addr); /* set addr so that addr_string is not
-                              * illformed */
+    tor_addr_from_null(&addr); /* set addr so that addr_string is not illformed */
   }
 
-  addr_string = tor_dup_ip(addr);
-  if (is_internal_IP(addr, 0)) {
+  addr_string = tor_dup_ip(&addr);
+  if (tor_addr_is_internal(&addr, 0)) {
     /* make sure we're ok with publishing an internal IP */
     if (!options->DirServers && !options->AlternateDirAuthority) {
       /* if they are using the default dirservers, disallow internal IPs
@@ -2525,19 +2519,17 @@ resolve_my_address(int warn_severity, or_options_t *options,
     }
   }
 
-  log_debug(LD_CONFIG, "Resolved Address to '%s'.", fmt_addr32(addr));
-  *addr_out = addr;
-  if (last_resolved_addr && last_resolved_addr != *addr_out) {
+  log_debug(LD_CONFIG, "Resolved Address to '%s'.", fmt_addr(&addr));
+  tor_addr_copy(addr_out,&addr);
+  if (!tor_addr_is_null(&addr) && !tor_addr_eq(&last_resolved_addr, addr_out)) {
+    const char *method;
+    const char *h = hostname;
     /* Leave this as a notice, regardless of the requested severity,
      * at least until dynamic IP address support becomes bulletproof. */
     log_notice(LD_NET,
                "Your IP address seems to have changed to %s. Updating.",
                addr_string);
     ip_address_changed(0);
-  }
-  if (last_resolved_addr != *addr_out) {
-    const char *method;
-    const char *h = hostname;
     if (explicit_ip) {
       method = "CONFIGURED";
       h = NULL;
@@ -2568,24 +2560,31 @@ is_local_addr(const tor_addr_t *addr)
 {
   if (tor_addr_is_internal(addr, 0))
     return 1;
-  /* Check whether ip is on the same /24 as we are. */
+  /* Check whether ip is on the same /24 (IPv4) or /48 (IPv6) as we are. */
   if (get_options()->EnforceDistinctSubnets == 0)
     return 0;
   if (tor_addr_family(addr) == AF_INET) {
-    /*XXXX023 IP6 what corresponds to an /24? */
     uint32_t ip = tor_addr_to_ipv4h(addr);
+    uint32_t lip = tor_addr_to_ipv4h(&last_resolved_addr);
 
     /* It's possible that this next check will hit before the first time
      * resolve_my_address actually succeeds.  (For clients, it is likely that
      * resolve_my_address will never be called at all).  In those cases,
      * last_resolved_addr will be 0, and so checking to see whether ip is on
      * the same /24 as last_resolved_addr will be the same as checking whether
-     * it was on net 0, which is already done by is_internal_IP.
+     * it was on net 0, which is already done by tor_addr_is_internal.
      */
-    if ((last_resolved_addr & (uint32_t)0xffffff00ul)
-        == (ip & (uint32_t)0xffffff00ul))
+    if ((lip & (uint32_t)0xffffff00ul) == (ip & (uint32_t)0xffffff00ul))
       return 1;
   }
+  else if (tor_addr_family(addr) == AF_INET6) {
+    /* XXX: The problem with last_resolved_addr is:
+     * - it is IPv4 only (and in an int, not even a tor_addr)
+     * - We can't have multiple of them:
+     *   - would need at least IPv4 + IPv6 in minimum case
+     *   - a host might have multiple IPv4 and IPv6 addresses...
+     */
+  }
   return 0;
 }
 
@@ -2730,6 +2729,8 @@ config_init(config_format_t *fmt, void *options)
   config_var_t *var;
   CHECK(fmt, options);
 
+  tor_addr_from_loopback(&last_resolved_addr, AF_INET);
+
   for (i=0; fmt->vars[i].name; ++i) {
     var = &fmt->vars[i];
     if (!var->initvalue)
@@ -2998,10 +2999,10 @@ options_validate(or_options_t *old_options, or_options_t *options,
     for (line = opt; line; line = line->next) {
       char *address = NULL;
       uint16_t port;
-      uint32_t addr;
+      tor_addr_t addr;
       if (parse_addr_port(LOG_WARN, line->value, &address, &addr, &port)<0)
         continue; /* We'll warn about this later. */
-      if (!is_internal_IP(addr, 1) &&
+      if (!tor_addr_is_internal(&addr, 1) &&
           (!old_options || !config_lines_eq(old, opt))) {
         log_warn(LD_CONFIG,
              "You specified a public address '%s' for a %s. Other "
@@ -3043,7 +3044,7 @@ options_validate(or_options_t *old_options, or_options_t *options,
 
   if (authdir_mode(options)) {
     /* confirm that our address isn't broken, so we can complain now */
-    uint32_t tmp;
+    tor_addr_t tmp;
     if (resolve_my_address(LOG_WARN, options, &tmp, NULL) < 0)
       REJECT("Failed to resolve/guess local address. See logs for details.");
   }
diff --git a/src/or/config.h b/src/or/config.h
index 49f7e25..a1f517d 100644
--- a/src/or/config.h
+++ b/src/or/config.h
@@ -27,7 +27,7 @@ void config_free_lines(config_line_t *front);
 setopt_err_t options_trial_assign(config_line_t *list, int use_defaults,
                                   int clear_first, char **msg);
 int resolve_my_address(int warn_severity, or_options_t *options,
-                       uint32_t *addr, char **hostname_out);
+                       tor_addr_t *addr, char **hostname_out);
 int is_local_addr(const tor_addr_t *addr) ATTR_PURE;
 void options_init(or_options_t *options);
 char *options_dump(or_options_t *options, int minimal);
diff --git a/src/or/connection.c b/src/or/connection.c
index 099482b..ae398bc 100644
--- a/src/or/connection.c
+++ b/src/or/connection.c
@@ -68,9 +68,9 @@ static int connection_read_https_proxy_response(connection_t *conn);
 static void connection_send_socks5_connect(connection_t *conn);
 
 /** The last IPv4 address that our network interface seemed to have been
- * binding to, in host order.  We use this to detect when our IP changes. */
-static uint32_t last_interface_ip = 0;
-/** A list of uint32_ts for addresses we've used in outgoing connections.
+ * binding to, in host order.  We use this to detect when our IPv4 address changes. */
+static tor_addr_t last_interface_ip;
+/** A list of tor_addr_ts for addresses we've used in outgoing connections.
  * Used to detect IP address changes. */
 static smartlist_t *outgoing_addrs = NULL;
 
@@ -801,11 +801,11 @@ connection_expire_held_open(void)
  *
  * The listenaddr struct has to be freed by the caller.
  */
-static struct sockaddr_in *
+static struct sockaddr_storage *
 create_inet_sockaddr(const char *listenaddress, int listenport,
                      char **readable_address, socklen_t *socklen_out) {
-  struct sockaddr_in *listenaddr = NULL;
-  uint32_t addr;
+  struct sockaddr_storage *listenaddr = NULL;
+  tor_addr_t addr;
   uint16_t usePort = 0;
 
   if (parse_addr_port(LOG_WARN,
@@ -819,12 +819,9 @@ create_inet_sockaddr(const char *listenaddress, int listenport,
       usePort = listenport;
   }
 
-  listenaddr = tor_malloc_zero(sizeof(struct sockaddr_in));
-  listenaddr->sin_addr.s_addr = htonl(addr);
-  listenaddr->sin_family = AF_INET;
-  listenaddr->sin_port = htons((uint16_t) usePort);
-
-  *socklen_out = sizeof(struct sockaddr_in);
+  listenaddr = tor_malloc_zero(sizeof(*listenaddr));
+  tor_addr_to_sockaddr(&addr, usePort, listenaddr, sizeof(*listenaddr));
+  *socklen_out = sizeof(*listenaddr);
 
   return listenaddr;
 
@@ -917,7 +914,7 @@ connection_create_listener(const struct sockaddr *listensockaddr,
     return NULL;
   }
 
-  if (listensockaddr->sa_family == AF_INET) {
+  if (listensockaddr->sa_family == AF_INET || listensockaddr->sa_family == AF_INET6) {
     tor_addr_t addr;
     int is_tcp = (type != CONN_TYPE_AP_DNS_LISTENER);
 #ifndef MS_WINDOWS
@@ -931,7 +928,7 @@ connection_create_listener(const struct sockaddr *listensockaddr,
     log_notice(LD_NET, "Opening %s on %s:%d",
                conn_type_to_string(type), fmt_addr(&addr), usePort);
 
-    s = tor_open_socket(PF_INET,
+    s = tor_open_socket(tor_addr_protocol(&addr),
                         is_tcp ? SOCK_STREAM : SOCK_DGRAM,
                         is_tcp ? IPPROTO_TCP: IPPROTO_UDP);
     if (s < 0) {
@@ -1125,16 +1122,12 @@ connection_handle_listener_read(connection_t *conn, int new_type)
   int news; /* the new socket */
   connection_t *newconn;
   /* information about the remote peer when connecting to other routers */
-  char addrbuf[256];
-  struct sockaddr *remote = (struct sockaddr*)addrbuf;
+  struct sockaddr_storage remote;
   /* length of the remote address. Must be whatever accept() needs. */
-  socklen_t remotelen = (socklen_t)sizeof(addrbuf);
+  socklen_t remotelen = (socklen_t)sizeof(remote);
   or_options_t *options = get_options();
 
-  tor_assert((size_t)remotelen >= sizeof(struct sockaddr_in));
-  memset(addrbuf, 0, sizeof(addrbuf));
-
-  news = tor_accept_socket(conn->s,remote,&remotelen);
+  news = tor_accept_socket(conn->s,&remote,&remotelen);
   if (news < 0) { /* accept() error */
     int e = tor_socket_errno(conn->s);
     if (ERRNO_IS_ACCEPT_EAGAIN(e)) {
@@ -1158,7 +1151,7 @@ connection_handle_listener_read(connection_t *conn, int new_type)
   if (options->ConstrainedSockets)
     set_constrained_socket_buffers(news, (int)options->ConstrainedSockSize);
 
-  if (check_sockaddr_family_match(remote->sa_family, conn) < 0) {
+  if (check_sockaddr_family_match(remote.ss_family, conn) < 0) {
     tor_close_socket(news);
     return 0;
   }
@@ -1166,17 +1159,17 @@ connection_handle_listener_read(connection_t *conn, int new_type)
   if (conn->socket_family == AF_INET || conn->socket_family == AF_INET6) {
     tor_addr_t addr;
     uint16_t port;
-    if (check_sockaddr(remote, remotelen, LOG_INFO)<0) {
+    if (check_sockaddr((struct sockaddr *)&remote, remotelen, LOG_INFO)<0) {
       log_info(LD_NET,
                "accept() returned a strange address; trying getsockname().");
-      remotelen=sizeof(addrbuf);
-      memset(addrbuf, 0, sizeof(addrbuf));
-      if (getsockname(news, remote, &remotelen)<0) {
+      remotelen=sizeof(remote);
+      memset(&remote, 0, sizeof(remote));
+      if (getsockname(news, (struct sockaddr *)&remote, &remotelen)<0) {
         int e = tor_socket_errno(news);
         log_warn(LD_NET, "getsockname() for new connection failed: %s",
                  tor_socket_strerror(e));
       } else {
-        if (check_sockaddr((struct sockaddr*)addrbuf, remotelen,
+        if (check_sockaddr((struct sockaddr*)&remote, remotelen,
                               LOG_WARN) < 0) {
           log_warn(LD_NET,"Something's wrong with this conn. Closing it.");
           tor_close_socket(news);
@@ -1185,12 +1178,12 @@ connection_handle_listener_read(connection_t *conn, int new_type)
       }
     }
 
-    if (check_sockaddr_family_match(remote->sa_family, conn) < 0) {
+    if (check_sockaddr_family_match(remote.ss_family, conn) < 0) {
       tor_close_socket(news);
       return 0;
     }
 
-    tor_addr_from_sockaddr(&addr, remote, &port);
+    tor_addr_from_sockaddr(&addr, (struct sockaddr *)&remote, &port);
 
     /* process entrance policies here, before we even create the connection */
     if (new_type == CONN_TYPE_AP) {
@@ -1304,23 +1297,16 @@ connection_connect(connection_t *conn, const char *address,
                    const tor_addr_t *addr, uint16_t port, int *socket_error)
 {
   int s, inprogress = 0;
-  char addrbuf[256];
-  struct sockaddr *dest_addr;
+  struct sockaddr_storage dest_addr;
   int dest_addr_len;
   or_options_t *options = get_options();
-  int protocol_family;
 
   if (get_n_open_sockets() >= get_options()->_ConnLimit-1) {
     warn_too_many_conns();
     return -1;
   }
 
-  if (tor_addr_family(addr) == AF_INET6)
-    protocol_family = PF_INET6;
-  else
-    protocol_family = PF_INET;
-
-  s = tor_open_socket(protocol_family,SOCK_STREAM,IPPROTO_TCP);
+  s = tor_open_socket(tor_addr_protocol(addr),SOCK_STREAM,IPPROTO_TCP);
   if (s < 0) {
     *socket_error = tor_socket_errno(-1);
     log_warn(LD_NET,"Error creating network socket: %s",
@@ -1329,17 +1315,15 @@ connection_connect(connection_t *conn, const char *address,
   }
 
   if (options->OutboundBindAddress && !tor_addr_is_loopback(addr)) {
-    struct sockaddr_in ext_addr;
-
-    memset(&ext_addr, 0, sizeof(ext_addr));
-    ext_addr.sin_family = AF_INET;
-    ext_addr.sin_port = 0;
-    if (!tor_inet_aton(options->OutboundBindAddress, &ext_addr.sin_addr)) {
+    tor_addr_t ext_addr;
+    if (tor_addr_from_str(&ext_addr, options->OutboundBindAddress) < 0) {
       log_warn(LD_CONFIG,"Outbound bind address '%s' didn't parse. Ignoring.",
                options->OutboundBindAddress);
     } else {
-      if (bind(s, (struct sockaddr*)&ext_addr,
-               (socklen_t)sizeof(ext_addr)) < 0) {
+      int socklen;
+      struct sockaddr_storage ss;
+      socklen = tor_addr_to_sockaddr(&ext_addr, 0, &ss, sizeof(ss));
+      if (bind(s, (struct sockaddr*)&ss, socklen) < 0) {
         *socket_error = tor_socket_errno(s);
         log_warn(LD_NET,"Error binding network socket: %s",
                  tor_socket_strerror(*socket_error));
@@ -1354,15 +1338,14 @@ connection_connect(connection_t *conn, const char *address,
   if (options->ConstrainedSockets)
     set_constrained_socket_buffers(s, (int)options->ConstrainedSockSize);
 
-  memset(addrbuf,0,sizeof(addrbuf));
-  dest_addr = (struct sockaddr*) addrbuf;
-  dest_addr_len = tor_addr_to_sockaddr(addr, port, dest_addr, sizeof(addrbuf));
+  memset(&dest_addr,0,sizeof(dest_addr));
+  dest_addr_len = tor_addr_to_sockaddr(addr, port, &dest_addr, sizeof(dest_addr));
   tor_assert(dest_addr_len > 0);
 
   log_debug(LD_NET, "Connecting to %s:%u.",
             escaped_safe_str_client(address), port);
 
-  if (connect(s, dest_addr, (socklen_t)dest_addr_len) < 0) {
+  if (connect(s, (struct sockaddr*)&dest_addr, (socklen_t)dest_addr_len) < 0) {
     int e = tor_socket_errno(s);
     if (!ERRNO_IS_CONN_EINPROGRESS(e)) {
       /* yuck. kill it. */
@@ -1891,8 +1874,10 @@ retry_listeners(int type, config_line_t *cfg,
         struct sockaddr *listensockaddr;
         socklen_t listensocklen = 0;
 
+        /* XXX-IPv6: could gust use sockaddr_storage as everything fits in it */
         switch (socket_family) {
           case AF_INET:
+          case AF_INET6:
             listensockaddr = (struct sockaddr *)
                              create_inet_sockaddr(cfg_line->value,
                                                   port_option,
@@ -3598,13 +3583,13 @@ alloc_http_authenticator(const char *authenticator)
 static void
 client_check_address_changed(int sock)
 {
-  uint32_t iface_ip, ip_out; /* host order */
-  struct sockaddr_in out_addr;
-  socklen_t out_addr_len = (socklen_t) sizeof(out_addr);
-  uint32_t *ip; /* host order */
+  tor_addr_t iface_ip, ip_out;
+  struct sockaddr_storage out_addr;
+  socklen_t out_addr_len = (socklen_t)sizeof(out_addr);
+  tor_addr_t *ip;
 
-  if (!last_interface_ip)
-    get_interface_address(LOG_INFO, &last_interface_ip);
+  if (tor_addr_is_null(&last_interface_ip))
+    get_interface_address6(LOG_INFO, AF_UNSPEC, &last_interface_ip);
   if (!outgoing_addrs)
     outgoing_addrs = smartlist_create();
 
@@ -3616,27 +3601,27 @@ client_check_address_changed(int sock)
   }
 
   /* If we've used this address previously, we're okay. */
-  ip_out = ntohl(out_addr.sin_addr.s_addr);
-  SMARTLIST_FOREACH(outgoing_addrs, uint32_t*, ip_ptr,
-                    if (*ip_ptr == ip_out) return;
+  tor_addr_from_sockaddr(&ip_out, (const struct sockaddr *)&out_addr, NULL);
+  SMARTLIST_FOREACH(outgoing_addrs, tor_addr_t *, ip_ptr,
+                    if (tor_addr_eq(ip_ptr, &ip_out)) return;
                     );
 
   /* Uh-oh.  We haven't connected from this address before. Has the interface
    * address changed? */
-  if (get_interface_address(LOG_INFO, &iface_ip)<0)
+  if (get_interface_address6(LOG_INFO, AF_UNSPEC, &iface_ip)<0)
     return;
-  ip = tor_malloc(sizeof(uint32_t));
+  ip = tor_malloc(sizeof(*ip));
   *ip = ip_out;
 
-  if (iface_ip == last_interface_ip) {
+  if (tor_addr_eq(&iface_ip, &last_interface_ip)) {
     /* Nope, it hasn't changed.  Add this address to the list. */
     smartlist_add(outgoing_addrs, ip);
   } else {
     /* The interface changed.  We're a client, so we need to regenerate our
      * keys.  First, reset the state. */
     log(LOG_NOTICE, LD_NET, "Our IP address has changed.  Rotating keys...");
-    last_interface_ip = iface_ip;
-    SMARTLIST_FOREACH(outgoing_addrs, void*, ip_ptr, tor_free(ip_ptr));
+    tor_addr_copy(&last_interface_ip, &iface_ip);
+    SMARTLIST_FOREACH(outgoing_addrs, void *, ip_ptr, tor_free(ip_ptr));
     smartlist_clear(outgoing_addrs);
     smartlist_add(outgoing_addrs, ip);
     /* Okay, now change our keys. */
